// BeNews.h
#ifndef _BeNews_H
#define _BeNews_H 
#include <be/interface/View.h>
#include <be/interface/Window.h>
#include <be/app/Application.h>
#include <be/support/String.h>
#include <be/storage/Entry.h>
#include <be/storage/Directory.h>
#include <be/storage/FilePanel.h>
#include <be/interface/StringView.h>
#include <be/interface/Alert.h>
#include <be/interface/Rect.h>
#include <be/interface/Box.h>
#include <be/interface/ScrollBar.h>
#include <be/interface/ListView.h>
#include <be/interface/RadioButton.h>
#include <be/interface/ScrollView.h>
#include <be/interface/StatusBar.h> 
#include <be/interface/ListView.h>
#include <be/interface/Screen.h>
#include <be/app/Handler.h>

/* network specific headers */
#include </boot/develop/headers/be/net/netdb.h>
#include </boot/develop/headers/be/net/netinet/in.h>
#include </boot/develop/headers/be/net/netdb.h>
#include </boot/develop/headers/be/mail/E-mail.h>
#include <sys/socket.h>    
#include <ctype.h>    
#include <sys/socket.h>
#include <Path.h>

//version 5 fixes
#include <Button.h>
#include <storage/File.h>
#include <app/Roster.h>
#include <app/Clipboard.h>
//version 5 fixes ends

#include <TextControl.h>
#include <TextView.h> 
#include <CheckBox.h>
#include <Directory.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <Menu.h>
#include <MenuBar.h>
#include <MenuItem.h>

//Defines the header fields we will store for ALL messages
typedef struct
{
char Subject[256];
char Name[128];
char Date[80];
char MessageID[256];
bool Read;
char ReferenceID[5000];
int Count;//?
} Miniheader;

//Maximum NTTP idle time before doing STAT.
#define NNTP_Max_idle = 300;


class BeNewsView : public BView
{
public:
	BeNewsView(BRect frame, const char* name, uint32 resizeMask, uint32 flags);
	void Draw(BRect updateRect);
	
};

//Network Communication status window 
//for debuging and entertainment!
class Nstat : public BWindow
{
 public:
    Nstat();
	void NSStat(int,char*);
	void NSPer(int);
 private:	
    BView *background;
    BStringView *line1,*line2;
    BStringView *line3,*line4;

 };


class BeNewsWin : public BWindow
{
public:
	BeNewsWin();
	void Quit();
	//	Virtual member function overrides
public:	
	void			MessageReceived(BMessage* message);
	bool			QuitRequested(void);
	bool 			ConfigRead(void);
	bool 			ConfigWrite(void);
	//Network trasport functions
	bool            GetaSocket(void);
	bool 			NCommand(char *string);
	char*           NTTP_resp(int);
	unsigned int 	NLineReturn(void);
	bool			ReIntConnect(void);
	bool            AquireServer(void);
	void			NQuit(void);
	bool 			GetGroups(void);
	void			Knit(void);
	bool 			GetNewGroups(void);
	bool            RecoverResend(void);
	bool            GetGroup(char*);
	bool            Header2mini(Miniheader *Tv,long ,char*);
	int             INNHeader2mini(Miniheader *Tv,char*,char*);
	bool            INNHeader2miniPart2(Miniheader *Tv,char* ,char* ,long unsigned int );
	bool 			Authentication(void);
	char* 			GetTimeDate(bool);
    void         	RBGroupWin(void);
    void            ThreadViewWin(void);
    void			SKViewWin(void);
    void			SKReIndex(int RI);
    void			SKAdd(int RI,const char* Subject,const char* Author,const char* FileName);
    void            MakeThread(void);
    void			PurgeNewsFiles(void);
    void			PurgeKillFiles(void);
    void            FixGroup(int);
    int				IDCount(char*,char*,off_t);
    bool 			IDHaveFirst(char*,char*,char*,off_t);
    int				UIDCount(char*,char*,off_t);
    bool 			UIDHaveFirst(char*,char*,char*,off_t);
    bool            IndexToID(char *bp, off_t t, bool Msg);
    void            SKRemRebuild(int which);
    bool			BinaryDecode(char *FB);
    void			Help(void);
	//Must be public to call them from other threads
//	const static char BNewsVer[] = "BNews 0.1Beta[Dev ver] - 'touched by the hand of Aradia...'";
	const static char BNewsVer[] = "BNews 1.0b - (\"Never Forever.\") | http://www.paradiseplace.org.uk/BeOS/";
	char            CurrentGroupName[256];
	char            CurrentGroupFile[40];
	bool            GroupUnLocked;
	bool			ConnectLock;
	bool            DontCount;
	bool            StartRS;
	bool            ReBuildFull;
	bool			BeAppQuitLock;
	int				NewGroupOpt;
	int				index;
	//Config variables
	//Server and User
	bool 			Authenticate;
	char 			UserName[256];
	char			PassWord[256];
	bool            SaveSent;
	bool			SaveBin;
	bool			InvalidAd;
	char			UserID[128];
	char            UserOrg[128];
	char			EmailAdd[80];
	char			NickName[80];
	BView*			background;
	int				TriState;
	BButton*        Mgg;
	BButton*        Mga;
	BButton*        Kpt;
	BButton*        Snt;
	BButton*        Nar;
    BCheckBox*		URd;
	BListView*		ThreadView; 
	Nstat* 			Ns;

	BStringView		*Title2;
	BStringView		*Title3;
	BStringView		*TCount;
    long TEMP; 
    //[NNTP_$len] 512 = max + 3 for insurance
    char NTTP_Line[515];	
	//member functions
	private:
	BMenu*				BuildFileMenu(void) const;
	BMenu*				BuildHelpMenu(void) const;
	BMenu* 				BuildFileConfig(void) const;
	BMenu* 				BuildKillMenu(void) const;
    BMenu*				BuildGroupsMenu(void) const;
    BMenu*				BuildToolsMenu(void) const;
	BMenuBar* 			bnFullMenuBar;
	BListView* 			SubGlist;
	BButton*			Mvw;   
    BScrollBar 			*SRange;
    thread_id 			Tx;
    bool                OnlyUnread;
	bool				MarkAsRead;
	bool 	            NLoud;
	bool				INN;
	char 				Dateandtime[20];
	char                ArticleID[256];
	char                ThisArticleID[256];
	bool				m_bUsingFullMenuBar;
	bool                In_Thread;
	BStringView*		bnStatusView;
	BTextView*			Btexmain;
};

  
//New THREAD Functions.
//Declared after BeNewsWin so they and use it
int32		newthread(BeNewsWin*);
int32		newthread1(BeNewsWin*);
int32		newthread2(BeNewsWin*);
int32		newthread3(BeNewsWin*);

class ModalWait : public BWindow
{
public:
	ModalWait(void);
private:
    void			MessageReceived(BMessage* message);
};

class ManualFileDecode : public BWindow
{
public:
	ManualFileDecode(BeNewsWin* Bn);
	BView *background;
	BStringView		*Title2;
	BeNewsWin*		BNews;
	BPath path;
	BButton* Quit;
	char			Apath[512];
private:
	entry_ref		fp_ref;
	BFilePanel		*FileDialog;
    void			MessageReceived(BMessage* message);
};


int32 newthreadN1(ManualFileDecode*);

class BeNewMail : public BWindow
{
public:
BeNewMail(BeNewsWin* Bn,bool);

	Miniheader Article;
public:
	BTextView*		BodyView; 	
private:
    void			MessageReceived(BMessage* message);
    void			SendMail(void);
    BTextControl*	Uname;
    BTextControl*	Subject;
    BTextControl*	MailTo;
    BCheckBox*		AddSig;
    BeNewsWin* 		Bnews;
    BView*			background;
	BButton*		Quit;
	BButton*        Que;
	BButton*        Send;
	BButton*        Chek;
    bool SendNow;
    bool AdSig;
};

class BeRot13 : public BWindow
{
public:
	BeRot13(void);
	BTextView*		BodyView; 	
private: 
    void			MessageReceived(BMessage* message);
    BView*			background;
    BButton*		Quit;
	BButton*        Copy;
	BButton*		ROTit; 
    BButton*        Paste;
};

class BeNewsRead : public BWindow
{
public:
	BeNewsRead(BeNewsWin* Bn);
	int ReadMessage();
	void KeepMessage();
	int sel;
	char KillAddress[256];
private:
    void			MessageReceived(BMessage* message);
private:
    BTextControl*	Uname;
    BTextControl*	Subject;
    BeNewsWin* 		Bnews;
    BView*			background;
	BTextView*		HeadrView;
	BTextView*		BodyView; 
	BButton*		Quit;
	BButton*        Next;
	BButton*        Prev;
	BButton*        Kill;
	BButton*        Keep; 
	BButton*        ROT13;  
	BButton*        Flup;  
	BButton*        Mail;
	BButton*		Binary; 

};

class BeNewPost : public BWindow
{
public:
	BeNewPost(BeNewsRead* Br, BeNewsWin* Bn,bool newart);
	void			PostNewArticle(void);
    void			UUCode(void);
	int				sel;
	int				Binline;
	Miniheader 		Article;
	BTextView*		BodyView; 
	entry_ref		fp_ref;
	BFilePanel		*FileDialog;

private:
    void			MessageReceived(BMessage* message);
private:
    bool 			SendBinary;
    BTextControl*	Uname;
    BTextControl*	Subject;
    BTextControl*	Groups;
    BCheckBox*		XNoArchive;
    BCheckBox*		EditG;
    BCheckBox*		AddSig;
    BeNewsWin* 		Bnews;
    BeNewsRead*		Bread;
    BView*			background;
	BButton*		Quit;
	BButton*        Esig;
	BButton*        Chek;
	BButton*        Keep;  
	BButton*        Send;
	BButton*        ROT13;  
	BButton*		SBin;  
	ModalWait 		*modalwin;
    bool Ged;
    bool NArt;
    bool XNA;
    bool AdSig;
};


class SKViewIt : public BWindow
{ 
public: 
    SKViewIt(BeNewsWin *bn);
private:
    void			MessageReceived(BMessage* message);
    BTextControl*	PDate;
    BTextControl*	UGroup;
    BTextControl*	Uname;
    BTextControl*	Subject;
    BeNewsWin* 		Bnews;
    BView*			background;
	BTextView*		HeadrView;
	BTextView*		BodyView; 
	BButton*		Binary;
	BButton*        ROT13; 
	BButton*		Quit;
	char            KSA[512];
};


class BeSpellcheck : public BWindow
{
public:

BeSpellcheck(BeNewPost* Bp);
BeSpellcheck(BeNewMail* Bp);

	Miniheader Article;
private:
    void			MessageReceived(BMessage* message);
private:
    void			Common(void);
    void			CheckIt(void);
    void			Replacer(void);
    void			AddWord(void);
    BeNewPost* 		BPost;
    BeNewMail*      BPost1;
    BView*			background;
    BTextControl*	QWord;
    BTextControl*	RWord;
    BListView*		Others;
   	BButton*		Quit;
   	BButton*		Add;
	BButton*        Ignore;
	BButton*        Suggest;
	BButton*        Replace;
	void*           memoryalloc;
	void*			memoryalloc2;
	char*           fp;
	char*			xp;
	int				qlen;
	int				oldqlen;
	char			lword[512];
    off_t			size;
    off_t			pos;
	off_t			buffersize;
	bool			lookup;
 };


//Kill File Control!! :)
class BKillControl : public BWindow
{
public:
    BKillControl (char*,BeNewsWin*);
    void AddKillfile(void);
    void RemKillfile(void);
    void AddFilterfile(void);
    void RemFilterfile(void);
    void MakeKillScreen(void);
	char KillAdd[256];
	
private:
    void			MessageReceived(BMessage* message);
    BButton*		Quit;
    BButton*		Plonk;
    BButton*		Remov;
    BTextControl*	Trollname;
    BTextControl*	Badword;
    BListView*		KillFile;
    BListView*		KillFilter;
    bool 			Duration;
    bool            DontFetch;
    BeNewsWin* 		Bnews;
};

//Configure server and User
class GroupControl : public BWindow 
{

public:
	GroupControl(BRect,BeNewsWin*);
	void MessageReceived(BMessage* message);
	void GSearch(int fn);
	void GSelect(void);
	void GDselect(void);
	void GSavesubd(void);
	
private:
    BeNewsWin* Bn;
	BListView *list,*subd;
    BTextControl* GFind;
    BView *background;
     	    
};

//list new
//Configure server and User
class GroupNewList : public BWindow 
{

public:
	GroupNewList(BRect);
	void MessageReceived(BMessage* message);

	
private:
	BListView *list;
    BView *background;
     	    
};



class BeNewsConfig : public BWindow 
{
public:
	BeNewsConfig(BRect,BeNewsWin* Bn);
	void MessageReceived(BMessage* message);
	private:
	char Pass1[10]; 
	bool Auth_intial;
	BeNewsWin* BNews;
	BMenuBar* 			cFullMenuBar;

};

class BeUserConfig : public BWindow 
{
public:
	BeUserConfig(BRect,BeNewsWin* Bn);
	void MessageReceived(BMessage* message);
	//bool ConfigWrite(void);
	private:
	BeNewsWin* BNews;
	bool val_intial;

};

class BeReopConfig : public BWindow 
{
public:
	BeReopConfig(BRect,BeNewsWin* Bn);
	void MessageReceived(BMessage* message);
	private:
	BeNewsWin* BNews;
	BCheckBox* Dra;
	BCheckBox* Svu;
	BCheckBox* DSS;
	BCheckBox* DSA;
	BRadioButton *RbGread1;
	BRadioButton *RbGread2;
	BRadioButton *RbGread3;
	int  RadioVal;

};

class BeMainFind : public BWindow 
{
public:
	BeMainFind(BRect,BeNewsWin* Bn);
	void MessageReceived(BMessage* message);
	void MGSearch(int);
	private:
	BeNewsWin* BNews;
	BTextControl* Find;

};

class BeNewsApp : public BApplication
{
public:
	BeNewsApp(const char* signature);
	void ReadyToRun();
	void AboutRequested(void);
	
};



class EditSig : public BWindow
{
public:
	EditSig(void);
	int sel;
	Miniheader Article;
private:
    void			MessageReceived(BMessage* message);
    void			SaveSig(void);
private:
    BTextControl*	Uname;
    BTextControl*	Subject;
    BTextControl*	Groups;
    BCheckBox*		XNoArchive;
    BCheckBox*		EditG;
    BCheckBox*		AddSig;
    BeNewsWin* 		Bnews;
    BView*			background;
	BTextView*		HeadrView;
	BTextView*		BodyView; 
	BButton*		Quit;
	BButton*        Esig;
	BButton*        Chek;

	BButton*        Keep;  
	BButton*        Send;  
    bool Ged;
    bool NArt;
    bool XNA;
};

class ThreadItem : public BListItem 
{
  public:ThreadItem(char *s1,char *s2,char *s3,char *s4,bool b,BeNewsWin* Bn);
  ~ThreadItem(); 
  virtual void  DrawItem(BView *owner, BRect frame, bool complete = false);
  private:
       char			*thread1;
       char			*thread2;
       char			*thread3;
       char			*thread4;
       bool			Newthread;
       BeNewsWin*   BNews;
 };


class ThreadMake : public BListItem 
{
  public:ThreadMake(char *s1,char *s2,char *s3,char *s4,char *s5,BeNewsWin* Bn);
  ~ThreadMake(); 
  virtual void  DrawItem(BView *owner, BRect frame, bool complete = false);
  private:
       char			*thread1;
       char			*thread2;
       char			*thread3;
       char			*thread4;
       char			*thread5;
       BeNewsWin*   BNews;
 };


class GroupItem : public BListItem 
{
  public:GroupItem(char *s1,char *s2);
  ~GroupItem(); 
  virtual void  DrawItem(BView *owner, BRect frame, bool complete = false);
  private:
       char			*thread1;
       char			*thread2;
 };

class KillItem : public BListItem 
{
  public:KillItem(char *s1,char *s2,char *s3);
  ~KillItem(); 
  virtual void  DrawItem(BView *owner, BRect frame, bool complete = false);
  private:
       char			*thread1;
       char			*thread2;
       char			*thread3;
 };

#endif
